// Code generated by mockery v2.22.1. DO NOT EDIT.

package mocks

import (
	mock "github.com/stretchr/testify/mock"
	common "gitlab.com/cyverse/cacao-common/common"

	service "gitlab.com/cyverse/cacao-common/service"

	types "gitlab.com/cyverse/cacao/deployment-service/metadata/types"
)

// DeploymentRunStorage is an autogenerated mock type for the DeploymentRunStorage type
type DeploymentRunStorage struct {
	mock.Mock
}

// BatchGet provides a mock function with given fields: runIDs
func (_m *DeploymentRunStorage) BatchGet(runIDs []common.ID) ([]types.DeploymentRun, error) {
	ret := _m.Called(runIDs)

	var r0 []types.DeploymentRun
	var r1 error
	if rf, ok := ret.Get(0).(func([]common.ID) ([]types.DeploymentRun, error)); ok {
		return rf(runIDs)
	}
	if rf, ok := ret.Get(0).(func([]common.ID) []types.DeploymentRun); ok {
		r0 = rf(runIDs)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.DeploymentRun)
		}
	}

	if rf, ok := ret.Get(1).(func([]common.ID) error); ok {
		r1 = rf(runIDs)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Create provides a mock function with given fields: run
func (_m *DeploymentRunStorage) Create(run types.DeploymentRun) (common.ID, error) {
	ret := _m.Called(run)

	var r0 common.ID
	var r1 error
	if rf, ok := ret.Get(0).(func(types.DeploymentRun) (common.ID, error)); ok {
		return rf(run)
	}
	if rf, ok := ret.Get(0).(func(types.DeploymentRun) common.ID); ok {
		r0 = rf(run)
	} else {
		r0 = ret.Get(0).(common.ID)
	}

	if rf, ok := ret.Get(1).(func(types.DeploymentRun) error); ok {
		r1 = rf(run)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeletePlaceholder provides a mock function with given fields: id
func (_m *DeploymentRunStorage) DeletePlaceholder(id common.ID) (bool, error) {
	ret := _m.Called(id)

	var r0 bool
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (bool, error)); ok {
		return rf(id)
	}
	if rf, ok := ret.Get(0).(func(common.ID) bool); ok {
		r0 = rf(id)
	} else {
		r0 = ret.Get(0).(bool)
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(id)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Get provides a mock function with given fields: runID
func (_m *DeploymentRunStorage) Get(runID common.ID) (types.DeploymentRun, error) {
	ret := _m.Called(runID)

	var r0 types.DeploymentRun
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (types.DeploymentRun, error)); ok {
		return rf(runID)
	}
	if rf, ok := ret.Get(0).(func(common.ID) types.DeploymentRun); ok {
		r0 = rf(runID)
	} else {
		r0 = ret.Get(0).(types.DeploymentRun)
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(runID)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// GetLatestRun provides a mock function with given fields: deployment
func (_m *DeploymentRunStorage) GetLatestRun(deployment common.ID) (*types.DeploymentRun, error) {
	ret := _m.Called(deployment)

	var r0 *types.DeploymentRun
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID) (*types.DeploymentRun, error)); ok {
		return rf(deployment)
	}
	if rf, ok := ret.Get(0).(func(common.ID) *types.DeploymentRun); ok {
		r0 = rf(deployment)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.DeploymentRun)
		}
	}

	if rf, ok := ret.Get(1).(func(common.ID) error); ok {
		r1 = rf(deployment)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Init provides a mock function with given fields:
func (_m *DeploymentRunStorage) Init() error {
	ret := _m.Called()

	var r0 error
	if rf, ok := ret.Get(0).(func() error); ok {
		r0 = rf()
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// List provides a mock function with given fields: filter, pagination
func (_m *DeploymentRunStorage) List(filter types.DeploymentRunFilter, pagination service.RequestPagination) ([]types.DeploymentRun, error) {
	ret := _m.Called(filter, pagination)

	var r0 []types.DeploymentRun
	var r1 error
	if rf, ok := ret.Get(0).(func(types.DeploymentRunFilter, service.RequestPagination) ([]types.DeploymentRun, error)); ok {
		return rf(filter, pagination)
	}
	if rf, ok := ret.Get(0).(func(types.DeploymentRunFilter, service.RequestPagination) []types.DeploymentRun); ok {
		r0 = rf(filter, pagination)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).([]types.DeploymentRun)
		}
	}

	if rf, ok := ret.Get(1).(func(types.DeploymentRunFilter, service.RequestPagination) error); ok {
		r1 = rf(filter, pagination)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// Update provides a mock function with given fields: id, run, filter
func (_m *DeploymentRunStorage) Update(id common.ID, run types.DeploymentRunUpdate, filter types.DeploymentRunFilter) (bool, error) {
	ret := _m.Called(id, run, filter)

	var r0 bool
	var r1 error
	if rf, ok := ret.Get(0).(func(common.ID, types.DeploymentRunUpdate, types.DeploymentRunFilter) (bool, error)); ok {
		return rf(id, run, filter)
	}
	if rf, ok := ret.Get(0).(func(common.ID, types.DeploymentRunUpdate, types.DeploymentRunFilter) bool); ok {
		r0 = rf(id, run, filter)
	} else {
		r0 = ret.Get(0).(bool)
	}

	if rf, ok := ret.Get(1).(func(common.ID, types.DeploymentRunUpdate, types.DeploymentRunFilter) error); ok {
		r1 = rf(id, run, filter)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewDeploymentRunStorage interface {
	mock.TestingT
	Cleanup(func())
}

// NewDeploymentRunStorage creates a new instance of DeploymentRunStorage. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewDeploymentRunStorage(t mockConstructorTestingTNewDeploymentRunStorage) *DeploymentRunStorage {
	mock := &DeploymentRunStorage{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
